# -*- coding: utf-8 -*-
from setuphelpers import *

# Declaring specific app values (TO CHANGE)
bin_name_string = "Plex-%s-x86_64.exe"


def update_package():
    print("Download/Update package content from upstream binary sources")
    import json

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Specific app values
    app_name = control.name
    url_api = "https://plex.tv/api/downloads/6.json"

    # Getting latest informations from Github API
    json_load = json.loads(wgets(url_api, proxies=proxy))

    version = json_load["computer"]["Windows"]["version"].split("-")[0]
    url_dl = json_load["computer"]["Windows"]["releases"][0]["url"]

    latest_bin = bin_name_string % version

    print("Latest " + app_name + " version is: " + version)
    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxy)

        # Change version of the package
        print("Writing " + version + "-0 in WAPT\\control")
        from waptpackage import PackageEntry

        pe = PackageEntry()
        pe.load_control_from_wapt(os.getcwd())

        pe.version = version + "-0"
        pe.save_control_to_wapt(os.getcwd())
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")

    # Deleting outdated binaries
    for bin_in_dir in glob.glob("*.exe") or glob.glob("*.msi"):
        if bin_in_dir != latest_bin:
            print("Outdated binary: " + bin_in_dir + " Deleted")
            remove_file(bin_in_dir)
